/**********************************************************
RunUO 2.0 AoV C# script file
Official Age of Valor Script :: www.uovalor.com
Last modified by 
Filepath: scripts\Items\Skill Items\Ninjitsu\Fukiya.cs
Lines of code: 278
***********************************************************/


using System;
using Server;
using Server.Targeting;
using System.Collections;
using System.Collections.Generic;
using Server.ContextMenus;

namespace Server.Items
{
	[FlipableAttribute( 0x27AA, 0x27F5 )]
	public class Fukiya : Item, IUsesRemaining
	{
		private bool m_Using;
		private int m_UsesRemaining;

		private Poison m_Poison;

		[CommandProperty( AccessLevel.GameMaster )]
		public int UsesRemaining
		{
			get { return m_UsesRemaining; }
			set { m_UsesRemaining = value; InvalidateProperties(); }
		}

		[CommandProperty( AccessLevel.GameMaster )]
		public Poison Poison
		{
			get{ return m_Poison; }
			set{ m_Poison = value; InvalidateProperties(); }
		}

		public bool ShowUsesRemaining{ get{ return true; } set{} }

		[Constructable]
		public Fukiya() : base( 0x27AA )
		{
			Weight = 4.0;
			Layer = Layer.OneHanded;
		}

		public Fukiya( Serial serial ) : base( serial )
		{
		}

		public override void GetProperties( ObjectPropertyList list )
		{
			base.GetProperties( list );			

			
			if(m_UsesRemaining>0)
			{
			if ( m_Poison != null) list.Add( 1062412 + m_Poison.Level, m_UsesRemaining.ToString() );
			else list.Add( 1060584, m_UsesRemaining.ToString() ); // uses remaining: ~1_val~
			}
		}

		public override void OnDoubleClick( Mobile from )
		{
			if ( !IsChildOf( from ) )
				return;

			if ( m_UsesRemaining < 1 )
			{
				// You have no fukiya darts!
				from.SendLocalizedMessage( 1063325 );
			}
			else if ( m_Using )
			{
				// You are already using that fukiya.
				from.SendLocalizedMessage( 1063326 );
			}
			else if ( !BasePotion.HasFreeHand( from ) )
			{
				// You must have a free hand to use a fukiya.
				from.SendLocalizedMessage( 1063327 );
			}
			else
			{
				from.BeginTarget( 5, false, TargetFlags.Harmful, new TargetCallback( OnTarget ) );
			}
		}

		public void Shoot( Mobile from, Mobile target )
		{
			if ( from == target )
				return;

			if ( m_UsesRemaining < 1 )
			{
				// You have no fukiya darts!
				from.SendLocalizedMessage( 1063325 );
			}
			else if ( m_Using )
			{
				// You are already using that fukiya.
				from.SendLocalizedMessage( 1063326 );
			}
			else if ( !BasePotion.HasFreeHand( from ) )
			{
				// You must have a free hand to use a fukiya.
				from.SendLocalizedMessage( 1063327 );
			}
			else if (m_delayTable.Contains( from ))
			{
				from.SendMessage("You must wait a few moments before throwing another dart");
			}
			else if ( from.CanBeHarmful( target ) )
			{
				m_Using = true;
				
				new DelayTimer(from,5).Start();

				from.Direction = from.GetDirectionTo( target );

				if ( from.Body.IsHuman && !from.Mounted )
					from.Animate( 33, 2, 1, true, true, 0 );

				from.PlaySound( 0x52f );
				from.MovingEffect( target, 0x2804, 5, 0, false, false );
				from.CheckSkill( SkillName.Ninjitsu, -10.0, 120.0 );

				if ( BaseWeapon.GetFinalHitChance(from ,target,from.Skills[SkillName.Ninjitsu].Value,100,0)>Utility.RandomDouble())
				{
				
					if(BaseWeapon.CheckParry( target ))
					{
					from.SendMessage("Your dart is parried!");
					}
					else
					{					
					from.SendMessage("The dart hits the target!");
					Timer.DelayCall( TimeSpan.FromSeconds( 1.0 ), new TimerStateCallback( OnDartHit ), new object[]{ from, target } );
					}
				}
				else
				{
				from.SendMessage("The dart misses");
				ConsumeUse();
				}

				Timer.DelayCall( TimeSpan.FromSeconds( 2.5 ), new TimerCallback( ResetUsing ) );
			}
		}

		private void OnDartHit( object state )
		{
			object[] states = (object[])state;
			Mobile from = (Mobile)states[0];
			Mobile target = (Mobile)states[1];

			if ( !from.CanBeHarmful( target ) )
				return;

			from.DoHarmful( target );

			AOS.Damage( target, from, Utility.RandomMinMax( 4, 6 ), 100, 0, 0, 0, 0 );

			if ( m_Poison != null)
				target.ApplyPoison( from, m_Poison );

			ConsumeUse();
		}

		public void ConsumeUse()
		{
			if ( m_UsesRemaining < 1 )
				return;

			--m_UsesRemaining;

			InvalidateProperties();
		}

		public void ResetUsing()
		{
			m_Using = false;
		}

		private const int MaxUses = 10;

		public void Unload( Mobile from )
		{
			if ( UsesRemaining < 1 )
				return;

			FukiyaDarts darts = new FukiyaDarts( UsesRemaining );

			darts.Poison = m_Poison;

			from.AddToBackpack( darts );

			m_UsesRemaining = 0;
			m_Poison = null;

			InvalidateProperties();
		}

		public void Reload( Mobile from, FukiyaDarts darts )
		{
			int need = ( MaxUses - m_UsesRemaining );

			if ( need <= 0 )
			{
				// You cannot add anymore fukiya darts
				from.SendLocalizedMessage( 1063330 );
				return;
			}
			if(darts.Poison==null)
			{
				from.SendMessage("You must poison the darts first!");
				return;
			}

			if ( need > darts.UsesRemaining )
				need = darts.UsesRemaining;

				if (m_Poison == null || m_Poison.Level == darts.Poison.Level || m_UsesRemaining==0)
				{
					if ( m_Poison != null && m_Poison.Level < darts.Poison.Level )
						Unload( from );

					m_Poison = darts.Poison;
				}
				else
				{
					from.SendMessage( "You decide against mixing different poison types in same fukiya" ); 
					return;
				}

				m_UsesRemaining += need;
				darts.UsesRemaining -= need;

			if ( darts.UsesRemaining <= 0 )
				darts.Delete();

			InvalidateProperties();
			
		}

		public void OnTarget( Mobile from, object obj )
		{
			if ( Deleted || !IsChildOf( from ) )
				return;

			if ( obj is Mobile )
				Shoot( from, (Mobile) obj );
			else if ( obj is FukiyaDarts )
				Reload( from, (FukiyaDarts) obj );
			else
				from.SendLocalizedMessage( 1063329 ); // You can only load fukiya darts
		}

		public override void GetContextMenuEntries( Mobile from, List<ContextMenuEntry> list )
		{
			base.GetContextMenuEntries( from, list );

			if ( IsChildOf( from ) )
			{
				list.Add( new LoadEntry( this ) );
				list.Add( new UnloadEntry( this ) );
			}
		}

		private class LoadEntry : ContextMenuEntry
		{
			private Fukiya m_Fukiya;

			public LoadEntry( Fukiya fukiya ) : base( 6224, 0 )
			{
				m_Fukiya = fukiya;
			}

			public override void OnClick()
			{
				if ( !m_Fukiya.Deleted && m_Fukiya.IsChildOf( Owner.From ) )
					Owner.From.BeginTarget( 5, false, TargetFlags.Harmful, new TargetCallback( m_Fukiya.OnTarget ) );
			}
		}

		private class UnloadEntry : ContextMenuEntry
		{
			private Fukiya m_Fukiya;

			public UnloadEntry( Fukiya fukiya ) : base( 6225, 0 )
			{
				m_Fukiya = fukiya;

				Enabled = ( fukiya.UsesRemaining > 0 );
			}

			public override void OnClick()
			{
				if ( !m_Fukiya.Deleted && m_Fukiya.IsChildOf( Owner.From ) )
					m_Fukiya.Unload( Owner.From );
			}
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 1 );

			writer.Write( (int) m_UsesRemaining );

			Poison.Serialize( m_Poison, writer );
		}
		
	
		
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();

			switch ( version )
			{				
				case 1:
				case 0:
				{
					m_UsesRemaining = reader.ReadInt();

					m_Poison = Poison.Deserialize( reader );
					if(version<1)reader.ReadInt();

					break;
				}
			}
		}
		
		private static Hashtable m_delayTable = new Hashtable();
		
		private class DelayTimer : Timer
		{
			private Mobile m_from;
			private DateTime m_End;
			private TimeSpan delaytime=TimeSpan.FromSeconds( 4.0 );
			

			public DelayTimer( Mobile from,int duration ) : base( TimeSpan.FromSeconds( 1.0 ), TimeSpan.FromSeconds( 4.0 ) )
			{
				m_End = DateTime.Now + TimeSpan.FromSeconds(duration);
				m_delayTable[from] = from;
				m_from=from;

				Priority = TimerPriority.OneSecond;
			}

			protected override void OnTick()
			{
				if ( m_from.Deleted|| !m_from.Alive || DateTime.Now >= m_End || !m_delayTable.Contains( m_from ))
				{
					m_delayTable.Remove( m_from );

					Stop();
				}
			}
		}	
		
		
	}
}